/************************************************/

/*	BE Modelisation Geometrique	        */
/*		Loic Barthe			*/
/*	      IRIT - UPS - CNRS			*/

/************************************************/
/************************************************/
/************************************************/

/*	BE illustration des Blobs	        */

/************************************************/
/************************************************/


#ifndef __Blob__
#define __Blob__

#include "intervalle.h"

/* Structure de stockage d'un blob spherique et les types correspondants */
typedef struct sBlob {
	float centre [3];
	float R;
	float _1R8;
	float R2;
	float couleur [3];
	float sig;
} tBlob, *pBlob;


/* creation d'un blob a partir de :
	- son centre, 
	- son rayon d'influence, 
	- son signe (ajout ou retrait de matiere)
	- sa couleur */
pBlob creeBlob (float cx, float cy, float cz, float R, float sig, float rouge, float vert, float bleu);

/* deplace le centre du blob */
void translateBlob (pBlob b, float tx, float ty, float tz);

/* evaluation du champ de potentiel en un point P(x,y,z) */
float evalBlob (pBlob b, float x, float y, float z);

/* evaluation de la derivee partielle en x */
float dxBlob (pBlob p, float x, float y, float z);
/* evaluation de la derivee partielle en y */
float dyBlob (pBlob p, float x, float y, float z);
/* evaluation de la derivee partielle en z */
float dzBlob (pBlob p, float x, float y, float z);

/* evaluation de la fonction d'inclusion sur un intervalle 3D */
tIntervalle IevalBlob (pBlob b, tIntervalle x, tIntervalle y, tIntervalle z);

#endif
