#include "liste_points.h"
#include <stdio.h>
#include <malloc.h>

#define MAX(a,b) (a)>(b)?(a):(b)


pTabPoints creeTabPoints () {

	pTabPoints p = (pTabPoints) malloc (sizeof(tTabPoints));
	int i;
	
	p->nbPoints = 0;
	p->suivant = NULL;
	for (i=0;i<4096;i++) p->index[i]=i;
			
	return p;
}


void ajoutePointTab (pTabPoints t, tPNC p) {
	int i;
	
	for (i=0;i<3;i++) {
		t->points[t->nbPoints*3+i] = p.point[i];
		t->normales[t->nbPoints*3+i] = p.normale[i];
		t->couleurs[t->nbPoints*3+i] = p.couleur[i];
	}
	t->nbPoints += 1;
}

pListeTabPoints creeListeTabPoints () {

	pListeTabPoints l = (pListeTabPoints) malloc (sizeof(tListeTabPoints));
	
	l->premier = creeTabPoints();
	l->courant = l->premier;
	
	l->nbPoints = 0;

	return l;
}

void ajoutePointListe (pListeTabPoints l, tPNC p) {

	if (l->courant->nbPoints >= 4095) {
		pTabPoints t = creeTabPoints ();
		l->courant->suivant = t;
		l->courant = t;
		ajoutePointTab (l->courant, p);
	}
	else ajoutePointTab (l->courant, p);
	
	l->nbPoints +=1;
}

void detruireListeTabPoints (pListeTabPoints l) {

	pTabPoints courant, suivant;
	courant = l->premier;
	
	while (courant != NULL) {
		suivant = courant->suivant;
		free (courant);
		courant = suivant;	
	}
	
	free (l);
}


void construireListe (pListeTabPoints l, pSum s, int prof_max, int prof_courante, float iso, tIntervalle X, tIntervalle Y, tIntervalle Z) {

/******************************************************************
                    A coder par les étudiants
*******************************************************************/

}


pListeTabPoints creeListeTabPointsSumBlob (pSum s, int profondeur, float iso, tIntervalle X, tIntervalle Y, tIntervalle Z) {

	pListeTabPoints l = creeListeTabPoints ();
	
	construireListe (l, s, profondeur, 0, iso, X, Y, Z);
	
	return l;
}

void afficheTabPoints (pTabPoints t, float taillePoint) {
	
	float specular [] = {0.9,0.9,0.9,1.};
	float shininess = 70.;
	float pointParam [] = {0.,0.,0.,0.};
	float vp[4];
	float mp[16];
	
	
	glGetFloatv(GL_VIEWPORT, vp);
	glGetFloatv(GL_PROJECTION_MATRIX, mp);
	
	
	pointParam[2] = MAX(vp[2]*mp[0],vp[3]*mp[5]);
	pointParam[2] *= pointParam[2];
	pointParam[2] = 1./pointParam[2];
	
	//printf ("%f \n",pointParam[2]);
	
	glEnable(GL_COLOR_MATERIAL);
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specular);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, shininess);
	
	glPointSize(taillePoint);
	//glPointParameterf(GL_POINT_SIZE_MIN, 1.);
	//glPointParameterf(GL_POINT_SIZE_MAX, 20.);
	glPointParameterfv(GL_POINT_DISTANCE_ATTENUATION, pointParam);
	
	glColor3f (t->couleurs[0], t->couleurs[1], t->couleurs[2]);
	
	glEnableClientState (GL_VERTEX_ARRAY);
	glEnableClientState (GL_NORMAL_ARRAY);
	glEnableClientState (GL_COLOR_ARRAY);
	
	glVertexPointer (3,GL_FLOAT,0,t->points);
	glNormalPointer (GL_FLOAT,0,t->normales);
	glColorPointer (3,GL_FLOAT,0,t->couleurs);
	
	glDrawElements (GL_POINTS,t->nbPoints,GL_UNSIGNED_INT,t->index);
	
	glDisableClientState (GL_VERTEX_ARRAY);
	glDisableClientState (GL_NORMAL_ARRAY);
	glDisableClientState (GL_COLOR_ARRAY);
	
	glDisable(GL_COLOR_MATERIAL);
}

void afficheListeTabPoints (pListeTabPoints l, float taillePoint) {

	pTabPoints t = l->premier;
	
	glEnable (GL_POINT_SMOOTH);

	while (t != NULL) {
		afficheTabPoints (t, taillePoint);
		t = t->suivant;
	}
}

